#include <ListViewConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIListView.au3>
#include <Array.au3>

#include "Include\Utilities.au3"

Global $aDeviceList[0], $bListen = False, $hDLL

Opt("GUICloseOnEsc", 0)
$hDeviceGUI = GUICreate("Device Identifier", 458, 315)
$hKeyLV = GUICtrlCreateListView("Device ID|Key|ScanCode|State", 8, 8, 442, 270)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 196)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 85)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 2, 70)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 3, 70)
$hDeviceList = GUICtrlCreateCombo("", 8, 286, 213, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
$hListenToggle = GUICtrlCreateCheckbox("Listen to keys", 232, 284, 85, 25)
$hSelectDevice = GUICtrlCreateButton("Select Device", 328, 285, 123, 23)
GUISetState(@SW_SHOW)

While 1
	If BitAND(GUICtrlRead($hListenToggle), 4) Then
		$bListen = False
		DllClose($hDLL)
	ElseIf Not BitAND(GUICtrlRead($hListenToggle), 4) Then
		$bListen = True
		$hDLL = DllOpen("InterceptionHelper.dll")
	EndIf

	Switch GUIGetMsg()
		Case -3
			Exit

		Case $hSelectDevice
			If GUICtrlRead($hDeviceList) = "" Then
				MsgBox(48, "No Device", "No valid device was selected.")
			Else
				IniWrite("settings.ini", "Settings", "Device", GUICtrlRead($hDeviceList))
				ShellExecute("Extensa.exe")
				ExitLoop
			EndIf
	EndSwitch

	If $bListen Then
		$aResult = _GetKey($hDLL)

		If $aResult[0] <> 0 Then
			$hListViewItem = GUICtrlCreateListViewItem($aResult[0] & "|" & $aScanCodes[$aResult[1]] & "|" & $aResult[1] & "|" & $aResult[2], $hKeyLV)

			$bFound = False
			For $i = 0 To UBound($aDeviceList) - 1
				If $aResult[0] = $aDeviceList[$i] Then
					$bFound = True
					ExitLoop
				EndIf
			Next

			If Not $bFound Then
				ReDim $aDeviceList[UBound($aDeviceList) + 1]
				$aDeviceList[UBound($aDeviceList) - 1] = $aResult[0]
			EndIf

			GUICtrlSetData($hDeviceList, "")

			Local $sString = ""
			For $i = 0 To UBound($aDeviceList) - 1
				$sString &= $aDeviceList[$i] & "|"
			Next

			$sString = StringTrimRight($sString, 1)
			GUICtrlSetData($hDeviceList, $sString)
			ControlCommand($hDeviceGUI, "", $hDeviceList, "SelectString", $aResult[0])
		EndIf
	EndIf
WEnd